/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
	"fmt"
)

// WriterSource the model 'WriterSource'
type WriterSource string

// List of WriterSource
const (
	WriterSourceMessageText WriterSource = "message_text"
	WriterSourceStatic WriterSource = "static"
	MESSAGE_BUTTON_PAYLOAD WriterSource = "message_button_payload"
	MESSAGE_MEDIA WriterSource = "message_media"
	MESSAGE_LOCATION_LAT WriterSource = "message_location_lat"
	MESSAGE_LOCATION_LNG WriterSource = "message_location_lng"
)

// All allowed values of WriterSource enum
var AllowedWriterSourceEnumValues = []WriterSource{
	"message_text",
	"static",
	"message_button_payload",
	"message_media",
	"message_location_lat",
	"message_location_lng",
}

func (v *WriterSource) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := WriterSource(value)
	for _, existing := range AllowedWriterSourceEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid WriterSource", value)
}

// NewWriterSourceFromValue returns a pointer to a valid WriterSource
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewWriterSourceFromValue(v string) (*WriterSource, error) {
	ev := WriterSource(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for WriterSource: valid values are %v", v, AllowedWriterSourceEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v WriterSource) IsValid() bool {
	for _, existing := range AllowedWriterSourceEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to WriterSource value
func (v WriterSource) Ptr() *WriterSource {
	return &v
}

type NullableWriterSource struct {
	value *WriterSource
	isSet bool
}

func (v NullableWriterSource) Get() *WriterSource {
	return v.value
}

func (v *NullableWriterSource) Set(val *WriterSource) {
	v.value = val
	v.isSet = true
}

func (v NullableWriterSource) IsSet() bool {
	return v.isSet
}

func (v *NullableWriterSource) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWriterSource(val *WriterSource) *NullableWriterSource {
	return &NullableWriterSource{value: val, isSet: true}
}

func (v NullableWriterSource) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWriterSource) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

